import com.vividsolutions.jump.workbench.plugin.AbstractPlugIn;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.*;
import com.vividsolutions.jump.feature.*;
import com.vividsolutions.jts.geom.*;
import java.util.*;
import java.io.File;
import javax.swing.*;
import java.awt.Component;
import com.vividsolutions.jump.workbench.ui.*;
import com.vividsolutions.jump.io.*;
import com.vividsolutions.jump.workbench.model.*;

import com.vividsolutions.jts.geom.GeometryFactory.*;

public class BufferBatchPlugIn extends AbstractPlugIn {
    //private Layer itemLayer = null; 
    
  public void initialize(PlugInContext context){
        context.getFeatureInstaller().addMainMenuItem(this, new String[] { "Nstroje", "batch" }, "buffer", false, null, null);
  }
    
  public boolean execute(PlugInContext context) throws Exception {   
       
         
          File fname = new File("");        
          JFileChooser chooser = new JFileChooser();
          chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
          chooser.setDialogTitle("Vyber adres");
          Component parent = context.getWorkbenchFrame();
          int returnVal = chooser.showOpenDialog(parent);   
          
        if(returnVal == JFileChooser.APPROVE_OPTION) {
                //fname = chooser.getSelectedFile().getPath();
                fname = chooser.getSelectedFile();
            } 
                              
          File[] files = fname.listFiles();
          
          for (File f : files) {
              
                           
              if ( f.getName().toLowerCase().endsWith(".shp")) {
                
                                               
                     try {
       
                         ShapefileReader reader = new ShapefileReader();
                         ShapefileWriter writer = new ShapefileWriter();
                         
                         ArrayList <Geometry> buffers;
                         buffers = new ArrayList<Geometry>();
                         
                         FeatureCollection fc = reader.read(new DriverProperties(f.getAbsolutePath()));
                                                       
                         Iterator i = fc.iterator();
                         while (i.hasNext()) {
                             Feature feature = (Feature) i.next();       
                             Geometry geom = feature.getGeometry();
                             Geometry buffer = geom.buffer(0.05);
                             buffers.add(buffer);
                            }  


                         FeatureCollection vrstvaBufferu = FeatureDatasetFactory.createFromGeometry(buffers);
                         
                         
                         File target = new File(fname, "buffer"+f.getName());
                         writer.write(vrstvaBufferu, new DriverProperties(target.getAbsolutePath()));        
                         context.addLayer("Buffer", "buffer_"+f.getName() , vrstvaBufferu );
                         
                         buffers.clear();
        
                        } catch(Exception e) {
       
                            //System.out.println("chyba");
                            
                        }
                                 
                   } 
            }
                           
          return true;           
                      
  }
   
 
} 


        